# -*- coding: utf-8 -*-
"""
Created on Mon Dec  4 11:33:15 2017

@author: belza
"""
import numpy as np
import time
class avion:
    addr = -1
    flightnum = 'UNKNOWN'
    planetype = 0
    lat0 = 0
    lat1 = 0
    lon0 = 0
    lat0 = 0
    time0 = -1
    time1 = -1
    cantidad_vistas =0
    cantidad_posiciones = 0
    cant_pos_procesadas = 0
    color = 0
    numero = 0
    hora_inicial = 0
    hora_final = 0
    directorio = "~/Documentos/vuelos"
    
    
    
    def __init__( self, addr,numero,colores,directorio):
        self.addr = addr;
        self.posiciones = []
        self.headings = []
        self.alturas = []
        self.velocidades = []
        self.velocidades_vert =[]
        self.vectvels = []
        self.difs_bar =[]
        self.air_speeds = []
        self.numero = numero
        self.color = colores[self.numero]
        self.directorio = directorio
        self.hora_inicial = time.time()
        
    def addplanetype( self, planetype ):
        self.planetype = planetype;
    
    def addflightnum( self, flightnum ):
        self.flightnum = flightnum;
        
    def addposition( self, posicion ):
        self.posiciones.append(posicion);
        self.hora_final = time.time()
        
    def addaltura( self, altura, ):
        self.alturas.append([altura,time.time()]);
        self.hora_final = time.time()

    def addvelocidad_vert( self, vert_rate_sign,vert_rate):
        if vert_rate_sign == 0:
	        self.velocidades_vert.append([vert_rate,time.time()]);
        else:
	        self.velocidades_vert.append([-vert_rate,time.time()]);
        self.hora_final = time.time()

    def adddif_bar( self, dif_bar_sign,dif_bar):
        if dif_bar_sign == 0:
	        self.difs_bar.append([dif_bar,time.time()]);
        else:
	        self.difs_bar.append([-dif_bar,time.time()]);
        self.hora_final = time.time()


    def addvectvels(self, ew_velocity,ns_velocity,ew_dir,ns_dir):
        self.vectvels.append([ew_velocity,ns_velocity,ew_dir,ns_dir,time.time()]);
        self.hora_final = time.time()
    
    def salvaryborrar_datos(self):
        if self.flightnum != 'UNKNOWN':
                 f = open(self.directorio+"lat_"+str(self.flightnum)+"_"+str(time.strftime("%b %d %Y %H:%M:%S", time.gmtime(self.hora_inicial))), 'a')
                 for pos in self.posiciones:
                     aux = str(pos[0]) + "," + str(pos[1])+"\n"    
                     f.write(aux)
                 f.close()
                 self.posiciones = []
                 f = open(self.directorio+"alt_"+str(self.flightnum)+"_"+str(time.strftime("%b %d %Y %H:%M:%S", time.gmtime(self.hora_inicial))), 'a')
                 for altura in self.alturas:
                     aux = str(altura[0])+","+str(altura[1])+"\n"    
                     f.write(aux)
                 f.close()
                 self.alturas = []       
                 f = open(self.directorio+"velvert_"+str(self.flightnum)+"_"+str(time.strftime("%b %d %Y %H:%M:%S", time.gmtime(self.hora_inicial))), 'a')
                 for vel in self.velocidades_vert:
                     aux = str(vel[0])+","+str(vel[1])+"\n"    
                     f.write(aux)
                 f.close()
                 self.velocidades_vert =[]
                 f = open(self.directorio+"difbar_"+str(self.flightnum)+"_"+str(time.strftime("%b %d %Y %H:%M:%S", time.gmtime(self.hora_inicial))), 'a')
                 for vel in self.difs_bar:
                     aux = str(vel[0])+","+str(vel[1])+"\n"    
                     f.write(aux)
                 f.close()
                 self.difs_bar =[]
                 f = open(self.directorio+"datos__velh"+str(self.flightnum)+"_"+str(time.strftime("%b %d %Y %H:%M:%S", time.gmtime(self.hora_inicial))), 'a')
                 for vel in self.vectvels:
                     aux = str(vel[0])+","+str(vel[1])+","+str(vel[2])+","+str(vel[3])+","+str(vel[4])+"\n"    
                     f.write(aux)
                 f.close()
                 self.vectvels = []



         
    def nuevas_posiciones(self):
        pos = []
        if len(self.posiciones) >0:
            for posicion in self.posiciones:           
                 pos.append( [self.color,self.flightnum,posicion[0],posicion[1],self.numero,time.strftime("%b %d %Y %H:%M:%S", time.gmtime(self.hora_inicial))] )
        return pos
        
