# -*- coding: utf-8 -*-
"""
Created on Thu Oct  5 13:22:17 2017

@author: belza
This code was partially adapted of some code from public laboratories of Digital Signal Procesing course of Berkeley University
and some code from gr-adsb project
"""

from __future__ import division
import numpy as np
from rtl_adsb1 import show_flights


MODES_LONG_MSG_BITS = 112
MODES_SHORT_MSG_BITS = 56
MODES_LONG_MSG_BYTES  = (112/8)
MODES_SHORT_MSG_BYTES = (56/8)
y_avg = 0.001
threshold_db = 4
d_threshold = pow(10.0, threshold_db/20.0);

def decision(bit0, bit1,ref):
    #limite 3dB sobre y por debajo de la referencia (promedio de los 4 unos del preambulo)
    highlimit=ref*1.414;
    lowlimit=ref*0.707;
    if ((bit0 > lowlimit) and (bit0 < highlimit)):	
        firstchip_inref  = 1
    else:
        firstchip_inref  = 0
    if ((bit1 > lowlimit) and (bit1 < highlimit)):
        secondchip_inref = 1
    else:
        secondchip_inref = 0
    if(firstchip_inref and not secondchip_inref):
        decision = 1
        confidence = 1
    if(secondchip_inref and  not firstchip_inref):
        decision = 0
        confidence = 1
    if(firstchip_inref and secondchip_inref):
        if bit0 > bit1 :
                decision = 1
        else:
                decision = 0
        confidence = 0
    if( not firstchip_inref and not secondchip_inref):
        if bit0 > bit1 :
            decision = 1
        else:
            decision = 0
        if(decision):
            if(bit1 < lowlimit * 0.5): 
                confidence = 1
            else:
                confidence = 0;
        else: 
            if(bit0 < lowlimit * 0.5):
                confidence = 1
            else:
                confidence = 0
    return decision

 
def correlate_preamble(v,j):
    preamble_bits = [1,0,1,0,0,0,0,1,0,1]
    corr = 0.0
    for i in range(0,10):
            if preamble_bits[i]:
                corr = corr + v[j+i]
    return corr

def detectPreamble1(y):



	
     	
	

def data2bit1( msg ):







leer_archivos = 0    
fs = 2000000; # 2MHz sampling frequency
center_freq = 1090e6 # 1090 MHz center frequency
gain = 37 # gain
N_samples = 2048000 # number of sdr samples for each chunk of data
 
pos_ref = [-34.901112, -56.164532] # Montevideo latitude, longitude for initializing the map

functions = (detectPreamble1, data2bit1)

stop_flag = show_flights( fs, center_freq, gain, N_samples, pos_ref, functions,leer_archivos )

print("fin!")
